%% resampling from the covariance matrix of the AR model prameters -univariate case

% inputs:
% nr_MC_sim, number of desired MonteCarlo runs
% A, estimated coefficients of AR model (M*pM)
% ObsMat, observation matrix (pM*N-p, as in the output from idMVAR.m)

% coeff=eAm;
% nr_MC_sim=numboot;
% Sigma=eSu;

function outres=idARres(nr_MC_sim,coeff,Sigma,covBS)

coeff_cov_mat=covBS(1:size(covBS,1)-1,1:size(covBS,2)-1);
var_Sigma=covBS(size(covBS,1),size(covBS,2));

coeff_MC = mvnrnd(coeff,coeff_cov_mat,nr_MC_sim);
Sigma_MC=normrnd(Sigma,sqrt(var_Sigma),nr_MC_sim,1);

outres=[coeff_MC Sigma_MC];

%     M=size(A,1);
%     p=size(A,2)/M;
%     N=size(ObsMat,2)+p;
%     outres=[];
%     X=ObsMat';
%     Z=inv(X'*X);
%     for m=1:M %needs to be done separately for each time series
%         coeff=A(m,:)';
%         %coeff_cov_mat=Z*Su(m,m)*Z';
%         coeff_cov_mat=Z*Su(m,m); %%% NEW
%         % resampling of coefficients, assuming they come from a multivariate Gaussian
%         coeff_MC = mvnrnd(coeff,coeff_cov_mat,nr_MC_sim);
%         outres=[outres coeff_MC];     
%     end
% 
%     [L,Sw]=choldiag(Su);
%     for i=1:nr_MC_sim
%         W = sqrt(Sw)*randn(M,N);
%         U = L*W;
%         covU=cov(U');
%         tmp=[];
%         for m=1:M, tmp=[tmp covU(m,:)]; end
%         rSu(i,:)=tmp;    
%     end
%     outres=[outres rSu];

end




